Skip to navigation

Post a debit memo

View as Markdown

Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information.

Posts a debit memo to activate it. You can post debit memos only if you have the Billing permissions.

Authentication

AuthorizationBearer

Use Bearer {{token}} in the Authorization header for authentication.

Path parameters

debitMemoKeystringRequired
The unique ID or number of a debit memo. For example, 8a8082e65b27f6c3015ba419f3c2644e or DM00000001.

Headers

Accept-EncodingstringOptional

Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

Content-EncodingstringOptional

Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

Zuora-Track-IdstringOptional<=64 characters

A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

Zuora-Entity-IdsstringOptional

An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

Zuora-Org-IdsstringOptional

Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.

Zuora-VersionstringOptional

The minor API version.

For a list of available minor versions, see API upgrades.

Response headers

Content-EncodingstringOptional

This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.

Note that only the following MIME types support gzipped responses:

  • application/json
  • application/xml
  • text/html
  • text/csv
  • text/plain
RateLimit-LimitstringOptional

The request limit quota for the time window closest to exhaustion. See rate limits for more information.

RateLimit-Remainingdouble

The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.

RateLimit-Resetdouble

The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.

Zuora-Request-IdstringOptional
The Zuora internal identifier of the API call. You cannot control the value of this header.
Zuora-Track-IdstringOptional
A custom identifier for tracing the API call. If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. Otherwise, Zuora does not set this header.
Concurrency-Limit-TypestringOptional

The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.

For more information, see Concurrent request limits.

Concurrency-Limit-Limitinteger

The total number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Concurrency-Limit-Remaininginteger

The remaining number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Response

OK
accountIdstringOptional
The ID of the customer account associated with the debit memo.
accountNumberstringOptional
The number of the customer account associated with the debit memo.
amountdoubleOptional
The total amount of the debit memo.
autoPaybooleanOptional
Whether debit memos are automatically picked up for processing in the corresponding payment run. By default, debit memos are automatically picked up for processing in the corresponding payment run.
balancedoubleOptional
The balance of the debit memo.
beAppliedAmountdoubleOptional
The amount that is applied to the debit memo.
billToContactIdstring or nullOptional

The ID of the bill-to contact associated with the debit memo.

The value of this field is null if you have the Flexible Billing Attributes feature disabled.

billToContactSnapshotIdstring or nullOptional

The ID of the bill-to contact snapshot associated with the debit memo.

The value of this field is null if the bill rule Preserve snapshot of bill-to and sold-to contacts when billing documents are posted is disabled.

cancelledByIdstring or nullOptional
The ID of the Zuora user who cancelled the debit memo.
cancelledOnstring or nullOptional

The date and time when the debit memo was cancelled, in yyyy-mm-dd hh:mm:ss format.

currencystring or nullOptional

The currency of the debit memo.

Note: By default, the currency on a billing document matches the default currency set on the associated account. However, Zuora now offers a Multiple Currencies feature to support different currencies for billing documents, allowing flexibility beyond the account-level currency. For more information, see Multiple Currency.

commentstring or nullOptional
Comments about the debit memo.
createdByIdstringOptional
The ID of the Zuora user who created the debit memo.
createdDatestringOptional

The date and time when the debit memo was created, in yyyy-mm-dd hh:mm:ss format. For example, 2017-03-01 15:31:10.

debitMemoDatedateOptional

The date when the debit memo takes effect, in yyyy-mm-dd format. For example, 2017-05-20.

dueDatedateOptional

The date by which the payment for the debit memo is due, in yyyy-mm-dd format.

einvoiceErrorCodestring or nullOptional

The error code returned when the e-invoice file status is Failed. This code can either be a Zuora-generated error code or one returned by a third-party e-invoicing service provider.

Note: This field is available only if you have the E-Invoicing feature in Early Adopter phase enabled.

einvoiceErrorMessagestring or nullOptional

The error message returned when the e-invoice file status is Failed. This message can either be a Zuora-generated error message or one returned by a third-party e-invoicing service provider.

Note: This field is available only if you have the E-Invoicing feature in Early Adopter phase enabled.

einvoiceFileIdstring or nullOptional

The ID of the e-invoice file generated for the debit memo.

Note: This field is available only if you have the E-Invoicing feature in Early Adopter phase enabled.

einvoiceStatusenum or nullOptional

The status of the e-invoice file generation for the debit memo.

  • If e-invoice file generation succeeds, this field is either Generated or Success, and both the error code and message are empty, and the eInvoiceFileId field stores the ID of the generated e-invoice file.

  • If the responses from tax vendors such as Sovos or Avalara are taking too long, this field becomes RetrieveTimeOut. Once the vendor responds successfully, you can use the ‘Resync E-Invoice Status’ action to update the status automatically. You can view these updates in System Health telemetry.

  • If a failure occurs during e-invoice file generation, this field is Failed and an error code and an error message are returned respectively in the einvoiceErrorCode and einvoiceErrorMessage fields.

  • If e-invoice file generation conditionally succeeds, this field is ConditionalSuccess and an error code and an error message are returned respectively in the einvoiceErrorCode and einvoiceErrorMessage fields.

  • If the e-invoice file has been approved by the tax authority, this field is ApprovedByAuthority. The next status will be either Success or Rejected.

  • If the e-invoice file has been rejected by the government, this field is Rejected. You cannot resend this e-invoice; you must create a new invoice instead.

    Note: This field is available only if you have the E-Invoicing feature in Early Adopter phase enabled.

excludeItemBillingFromRevenueAccountingbooleanOptional

The flag to exclude the debit memo item from revenue accounting.

Note: This field is only available if you have the Billing - Revenue Integration feature enabled.

idstringOptional
The unique ID of the debit memo.
invoiceGroupNumberstring or nullOptional

The number of the invoice group associated with the debit memo.

The value of this field is null if you have the Flexible Billing Attributes feature disabled.

latestPDFFileIdstringOptional
The ID of the latest PDF file generated for the debit memo.
numberstringOptional
The unique identification number of the debit memo.
organizationLabelstringOptional

The organization that this object belongs to.

Note: This field is available only when the Multi-Org feature is enabled.

paymentTermstringOptional

The name of the payment term assoicated with the debit memo.

The value of this field is null if you have the Flexible Billing Attributes feature disabled.

postedByIdstring or nullOptional
The ID of the Zuora user who posted the debit memo.
postedOnstring or nullOptional

The date and time when the debit memo was posted, in yyyy-mm-dd hh:mm:ss format.

reasonCodestringOptional
A code identifying the reason for the transaction. The value must be an existing reason code or empty.
referredCreditMemoIdstringOptional
The ID of the credit memo from which the debit memo was created.
referredInvoiceIdstring or nullOptional
The ID of a referred invoice.
sequenceSetIdstring or nullOptional

The ID of the sequence set associated with the debit memo.

The value of this field is null if you have the Flexible Billing Attributes feature disabled.

communicationProfileIdstring or nullOptional

The ID of the communication profile associated with the debit memo.

Note: This field is available in the request body only if you have the Flexible Billing Attributes feature turned on. The value is null in the response body without this feature turned on.

soldToContactIdstring or nullOptional

The ID of the sold-to contact associated with the debit memo. The value of this field is null if you have the Flexible Billing Attributes feature disabled.

soldToContactSnapshotIdstring or nullOptional

The ID of the sold-to contact snapshot associated with the debit memo. The value of this field is null if you have the Flexible Billing Attributes feature disabled.

sourceTypeenumOptional
The type of the debit memo source.
statusenumOptional
The status of the debit memo.
successbooleanOptional

Returns true if the request was processed successfully.

targetDatedate or nullOptional

The target date for the debit memo, in yyyy-mm-dd format. For example, 2017-07-20.

taxAmountdoubleOptional
The amount of taxation.
taxMessagestring or nullOptional
The message about the status of tax calculation related to the debit memo. If tax calculation fails in one debit memo, this field displays the reason for the failure.
taxStatusenum or nullOptional

The status of tax calculation related to the debit memo.

Note: This field is only applicable to tax calculation by third-party tax engines. Also, the Voided status indicates that the tax transaction is successfully canceled on the tax vendor’s side. If a tax transaction was successfully committed to the third-party tax engine but the invoice failed to post, Zuora automatically detects the issue and voids the tax transaction on the vendor’s side.

totalTaxExemptAmountdoubleOptional
The calculated tax amount excluded due to the exemption.
transferredToAccountingenumOptional
Whether the debit memo was transferred to an external accounting system. Use this field for integration with accounting systems, such as NetSuite.
Allowed values:
updatedByIdstringOptional
The ID of the Zuora user who last updated the debit memo.
updatedDatestringOptional

The date and time when the debit memo was last updated, in yyyy-mm-dd hh:mm:ss format. For example, 2017-03-02 15:36:10.

IntegrationId__NSstringOptional<=255 characters

ID of the corresponding object in NetSuite. Only available if you have installed the Zuora Connector for NetSuite.

IntegrationStatus__NSstringOptional<=255 characters

Status of the debit memo’s synchronization with NetSuite. Only available if you have installed the Zuora Connector for NetSuite.

SyncDate__NSstringOptional<=255 characters

Date when the debit memo was synchronized with NetSuite. Only available if you have installed the Zuora Connector for NetSuite.

Errors

4XX
Client Request Error
500
Internal Server Error